// Copyright (C) 1996 DIMACS Center, Rutgers, The State University of New Jersey
// Author(s): Jonathan Berry
// This software is copyrighted by the DIMACS Center at Rutgers, The State
// University of New Jersey.  IT IS PROVIDED AS IS, AND THE AUTHORS, DIMACS, AND
// RUTGERS, THE STATE UNIVERSITY OF NEW JERSEY  DISCLAIM
// ALL LIABILITY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
// DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
// DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
// THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
// IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
// NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
// MODIFICATIONS.
// The authors hereby grant permission to use, copy, modify, distribute,
// and license this software and its documentation for any purpose, provided
// that existing copyright notices are retained in all copies and that this
// notice is included verbatim in any distributions. No written agreement,
// license, or royalty fee is required for any of the authorized uses.
// Modifications to this software may be copyrighted by their authors
// and need not follow the licensing terms described here, provided that
// the new terms are clearly indicated on the first page of each file where
// they apply.
// Last File Update: 7-Aug-1997
// 
#ifndef SetFuncs_h
#define SetFuncs_h
#include <iostream.h>
#include <LINK/basic/Array.h>
#include <LINK/basic/SubSet.h>
#include <LINK/basic/Permutation.h>
#include <LINK/basic/Set.h>
#include <LINK/basic/Sequence.h>
template <class Item>
class SetFuncs {
public:
	static Set<Set<Item> > 	    choose(const Set<Item>&, int);
	static Set<Set<Item> >      powerSet(const Set<Item>&);
	static Set<Sequence<Item> >      cartesianProduct(const Set<Item>&,
						     const Set<Item>&);
	static Sequence<Item>       permutation(const Set<Item>&, 
						const Permutation&);
	static Sequence<Item>       permutation(const Array<Item>&, 
						const Permutation&);
	static Set<Sequence<Item> > permutations(const Set<Item>&);
	int operator==(const SetFuncs<Item>& s) const
					{return 1;}
	int operator<(const SetFuncs<Item>& s) const
					{return 0;}
	friend ostream& operator<<(ostream& os, const SetFuncs<Item>& s);
private:
	static Set<SubSet<Item> > aux_choose(SubSet<Item>& original, int k);
};
#ifdef DEFINE_SetFuncs_TEMPLATE
#include<LINK/basic/SetFuncs.cpp>
#endif
#endif
