// Copyright (C) 1996 DIMACS Center, Rutgers, The State University of New Jersey
// Author(s): ??

// This software is copyrighted by the DIMACS Center at Rutgers, The State
// University of New Jersey.  IT IS PROVIDED AS IS, AND THE AUTHORS, DIMACS, AND
// RUTGERS, THE STATE UNIVERSITY OF NEW JERSEY  DISCLAIM
// ALL LIABILITY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
// DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
// DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.

// THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
// IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
// NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
// MODIFICATIONS.

// The authors hereby grant permission to use, copy, modify, distribute,
// and license this software and its documentation for any purpose, provided
// that existing copyright notices are retained in all copies and that this
// notice is included verbatim in any distributions. No written agreement,
// license, or royalty fee is required for any of the authorized uses.
// Modifications to this software may be copyrighted by their authors
// and need not follow the licensing terms described here, provided that
// the new terms are clearly indicated on the first page of each file where
// they apply.

// Last File Update: 31-Jul-1996
// 

#ifndef SortedArray_h
#define SortedArray_h

#include <LINK/basic/Container.h>
#include <LINK/basic/Array.h>

class Vertex;
class Edge;
template <class Item> class ArrayWrapper;

template <class Item>
class SortedArray : public Array<Item> {
public:
    SortedArray() : Array<Item>() {}
    SortedArray(int sz);
    SortedArray(const SortedArray<Item>& ar);
    SortedArray(const Container<Item>& ar);
    SortedArray<Item>&          operator=(const SortedArray<Item>&);
    Bool	                memberQ(const Item& item) const;
    Bool	                sortedQ() const { return TRUE; }
    Item              		min();
    Item                	max();
    int                 	search(const Item& item) const;
    ContainerNode*      	insert(const Item e);
    ContainerNode*      	append(const Item e);
};

#ifdef DEFINE_SortedArray_TEMPLATE
#include <LINK/basic/SortedArray.cpp>
#endif


#endif
