#include<stk.h>
#include<LINK/stkWrapper/LINK_STk.h>
#include<LINK/stkWrapper/Wrapper.h>
#include<LINK/stkWrapper/Register.h>
#include<LINK/generator/Generators.h>
#include<LINK/graph/UBinGraph.h>
#include<LINK/graph/Graph.h>

#include <stdio.h>
#include <stdlib.h>

static PRIMITIVE GenCycleCmd(SCM n)
{
        Graph *gr;
        if (!INTEGERP(n))
                Err("gen-cycle: bad arg 1, <integer> expected", n);
	int sz = INTEGER(n);
        Graph *g = GenCycle(sz);
        Register<Graph>::createEntry(Wrapper<UBinGraph>::type,
                                     Wrapper<UBinGraph>::name, g);
        Graph **gp = new Graph*(g);

        return STk_make_CXXwrapper(Wrapper<UBinGraph*>::type,
                Wrapper<UBinGraph*>::name, (void *) gp, LINK_DYNAMIC);
}

void gen_Cycle_Wrapper()
{
        STk_add_new_cpp_primitive("gen-cycle", tc_subr_1,
                               (PRIMITIVE (*)(...))GenCycleCmd);
}
#include<stk.h>
#include<LINK/stkWrapper/LINK_STk.h>
#include<LINK/stkWrapper/Wrapper.h>
#include<LINK/stkWrapper/Register.h>
#include<LINK/generator/Generators.h>
#include<LINK/graph/UBinGraph.h>
#include<LINK/graph/Graph.h>

#include <stdio.h>
#include <stdlib.h>

static PRIMITIVE GenRandomGraphCmd(SCM n, SCM p)
{
        Graph *gr;
        if (!INTEGERP(n))
                Err("gen-random-graph: bad arg 1, <integer> expected", n);
        if (!FLONUMP(p))
                Err("gen-random-graph: bad arg 2, <number> expected", n);
	int sz = INTEGER(n);
	double prob = FLONM(p);
        Graph *g = GenRandomGraph(sz, prob);
        Register<Graph>::createEntry(Wrapper<UBinGraph>::type,
                                     Wrapper<UBinGraph>::name, g);
        Graph **gp = new Graph*(g);
        return STk_make_CXXwrapper(Wrapper<UBinGraph*>::type,
                Wrapper<UBinGraph*>::name, (void *) gp, LINK_DYNAMIC);
}

void gen_RandomGraph_Wrapper()
{
        STk_add_new_cpp_primitive("gen-random-graph", tc_subr_2,
                               (PRIMITIVE (*)(...))GenRandomGraphCmd);
}
#include<stk.h>
#include<LINK/stkWrapper/LINK_STk.h>
#include<LINK/stkWrapper/Wrapper.h>
#include<LINK/stkWrapper/Register.h>
#include<LINK/generator/Generators.h>
#include<LINK/graph/UBinGraph.h>
#include<LINK/graph/Graph.h>

#include <stdio.h>
#include <stdlib.h>

static PRIMITIVE GenCompleteGraphCmd(SCM n)
{
        Graph *gr;
        if (!INTEGERP(n))
                Err("gen-cycle: bad arg 1, <integer> expected", n);
	int sz = INTEGER(n);
        Graph *g = GenCompleteGraph(sz);
        Register<Graph>::createEntry(Wrapper<UBinGraph>::type,
                                     Wrapper<UBinGraph>::name, g);
        Graph **gp = new Graph*(g);

        return STk_make_CXXwrapper(Wrapper<UBinGraph*>::type,
                Wrapper<UBinGraph*>::name, (void *) gp, LINK_DYNAMIC);
}

void gen_CompleteGraph_Wrapper()
{
        STk_add_new_cpp_primitive("gen-complete-graph", tc_subr_1,
                               (PRIMITIVE (*)(...))GenCompleteGraphCmd);
}
#include<stk.h>
#include<LINK/stkWrapper/LINK_STk.h>
#include<LINK/stkWrapper/Wrapper.h>
#include<LINK/stkWrapper/Register.h>
#include<LINK/generator/Generators.h>
#include<LINK/graph/UBinGraph.h>
#include<LINK/graph/Graph.h>

#include <stdio.h>
#include <stdlib.h>

static PRIMITIVE GenGridGraphCmd(SCM rows, SCM cols)
{
        Graph *gr;
        if (!INTEGERP(rows))
             Err("gen-grid-graph: bad arg 1, #rows (<integer>) expected", rows);
        if (!INTEGERP(cols))
             Err("gen-grid-graph: bad arg 1, #cols (<integer>) expected", cols);
	int r = INTEGER(rows);
	int c = INTEGER(cols);
        Graph *g = GenGridGraph(r, c);
        Register<Graph>::createEntry(Wrapper<UBinGraph>::type,
                                     Wrapper<UBinGraph>::name, g);
        Graph **gp = new Graph*(g);

        return STk_make_CXXwrapper(Wrapper<UBinGraph*>::type,
                Wrapper<UBinGraph*>::name, (void *) gp, LINK_DYNAMIC);
}

void gen_GridGraph_Wrapper()
{
        STk_add_new_cpp_primitive("gen-grid-graph", tc_subr_2,
                               (PRIMITIVE (*)(...))GenGridGraphCmd);
}
#include<stk.h>
#include<LINK/stkWrapper/LINK_STk.h>
#include<LINK/stkWrapper/Wrapper.h>
#include<LINK/stkWrapper/Register.h>
#include<LINK/generator/Generators.h>
#include<LINK/graph/DBinGraph.h>
#include<LINK/graph/Graph.h>

#include <stdio.h>
#include <stdlib.h>

static PRIMITIVE GenLatkaTournamentCmd(SCM i, SCM k)
{
        Graph *gr;
        if (!INTEGERP(i))
                Err("gen-latka-tournament: bad arg 1, <integer> expected", i);
        if (!INTEGERP(k))
                Err("gen-latka-tournament: bad arg 2, <integer> expected", i);
	int sz = INTEGER(i);
	int spread = INTEGER(k);
        Graph *g = GenLatkaTournament(sz, spread);
        Register<Graph>::createEntry(Wrapper<DBinGraph>::type,
                                     Wrapper<DBinGraph>::name, g);
        Graph **gp = new Graph*(g);

        return STk_make_CXXwrapper(Wrapper<DBinGraph*>::type,
                Wrapper<DBinGraph*>::name, (void *) gp, LINK_DYNAMIC);
}

void gen_LatkaTournament_Wrapper()
{
        STk_add_new_cpp_primitive("gen-latka-tournament", tc_subr_2,
                               (PRIMITIVE (*)(...))GenLatkaTournamentCmd);
}
#include<iostream.h>
#include<strstream.h>
#include<stk.h>
#include<LINK/stkWrapper/LINK_STk.h>
#include<LINK/stkWrapper/Wrapper.h>
#include<LINK/algorithm/Algorithms.h>
#include<LINK/algorithm/Partitioning.h>
#include<LINK/basic/Sequence.h>
#include<LINK/graph/Graph.h>
#include<LINK/graph/UBinGraph.h>
#include<LINK/graph/Edge.h>
#include<LINK/graph/Vertex.h>

static PRIMITIVE GenPruferWrapper(SCM elements, int len)
{
        SCM vlist, elist;
        Graph *g, **gp;
        char vname[10];
        Sequence<int> seq;

        if (len == 0)
                return wrapGraph(new MUBinGraph);
        if (STRINGP(CAR(elements))) {
		g = GenPrufer(STRING(CAR(elements)));
        } else {
        	SCM l=elements;
        	for (;;) {
                	if (NULLP(l))
                        	break;
                	if (!INTEGERP(CAR(l)))
				Err("gen-prufer: integer expected", CAR(l));
                	seq.append(INTEGER(CAR(l)));
                	l = CDR(l);
        	}
        	g = GenPrufer(seq.size()+2, seq);
        }
        return wrapGraph(g);
}

void gen_Prufer_Wrapper()
{
        STk_add_new_cpp_primitive("gen-prufer", tc_lsubr,
				 (PRIMITIVE (*)(...))GenPruferWrapper);
}
#include<stk.h>
#include<LINK/stkWrapper/LINK_STk.h>
#include<LINK/stkWrapper/Wrapper.h>
#include<LINK/stkWrapper/Register.h>
#include<LINK/generator/Generators.h>
#include<LINK/graph/UBinGraph.h>
#include<LINK/graph/Graph.h>

#include <stdio.h>
#include <stdlib.h>

static PRIMITIVE GenRegularCmd(SCM n, SCM k)
{
        Graph *gr;
        if (!INTEGERP(n))
             Err("gen-regular-graph: bad arg 1, #verts (<integer>) expected",n);
        if (!INTEGERP(k))
             Err("gen-regular-graph: bad arg 2, degree (<integer>) expected",k);
	int r = INTEGER(n);
	int c = INTEGER(k);
        MUBinGraph *g = GenRegularGraph(r, c);
        Register<Graph>::createEntry(Wrapper<MUBinGraph>::type,
                                     Wrapper<MUBinGraph>::name, g);
        Graph **gp = new Graph*(g);

        return STk_make_CXXwrapper(Wrapper<MUBinGraph*>::type,
                Wrapper<MUBinGraph*>::name, (void *) gp, LINK_DYNAMIC);
}

void gen_Regular_Wrapper()
{
        STk_add_new_cpp_primitive("gen-regular-graph", tc_subr_2,
                               (PRIMITIVE (*)(...))GenRegularCmd);
}
#include<stk.h>
#include<LINK/stkWrapper/LINK_STk.h>
#include<LINK/stkWrapper/Wrapper.h>
#include<LINK/stkWrapper/Register.h>
#include<LINK/generator/Generators.h>
#include<LINK/graph/UHyperGraph.h>
#include<LINK/graph/Graph.h>

#include <stdio.h>
#include <stdlib.h>

static PRIMITIVE GenUHyperGraphKUCmd(SCM n, SCM m, SCM k)
{
        Graph *gr;
        if (!INTEGERP(n))
            Err("gen-uniform-hypergraph: bad arg 1, #v (<integer>) expected",n);
        if (!INTEGERP(m))
            Err("gen-uniform-hypergraph: bad arg 1, #e (<integer>) expected",m);
        if (!INTEGERP(k))
            Err("gen-uniform-hypergraph: bad arg 1, #v (<integer>) expected",k);
	int num_verts = INTEGER(n);
	int num_edges = INTEGER(m);
	int edge_size = INTEGER(k);
        Graph *g = GenUHyperGraphKU(num_verts, num_edges, edge_size);
        Register<Graph>::createEntry(Wrapper<UBinGraph>::type,
                                     Wrapper<UBinGraph>::name, g);
        Graph **gp = new Graph*(g);

        return STk_make_CXXwrapper(Wrapper<UHyperGraph*>::type,
                Wrapper<UBinGraph*>::name, (void *) gp, LINK_DYNAMIC);
}

void gen_UHyperGraphKU_Wrapper()
{
        STk_add_new_cpp_primitive("gen-uniform-hypergraph", tc_subr_3,
                               (PRIMITIVE (*)(...))GenUHyperGraphKUCmd);
}
