#include <stk.h>
#include<LINK/stkWrapper/LINK_STk.h>
#include<LINK/stkWrapper/Wrapper.h>
#include<LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/CollectionWrapper.h>
#include <LINK/userobj/PostAnalyze.h>


 
static PRIMITIVE ExtractWrapper(SCM parms, int len)
{
        SCM g=UNBOUND, percent=UNBOUND, flag=UNBOUND, deviate=UNBOUND;

        Graph *gr;

	int deviatE = 1; 

        if (len != 5 && len !=4)  
	{
	   Err("usage: extract <num_verts><edge probability><percent checked><Sequence>",
		UNDEFINED);
	   Err("<1 or 0>[<deviation>]", UNDEFINED);
	}

	g = CAR(parms);
        if (!(gr = getGraph(g)))   // see src/stkWrapper/stkUtils.cc
                Err("extract: bad arg 1, expected <graph*> ", g);
 

        percent = CAR(CDR(parms));
 
        if (!INTEGERP(percent))
                Err("extract: bad arg 2, integer expected (percent)", percent);
        int percenT = INTEGER(percent);
 

        flag = CAR(CDR(CDR(parms)));

        if (!INTEGERP(flag))
                Err("extract: bad arg 3, integer expected (flag)", flag);
        int flaG = INTEGER(flag);


	SCM vset = CAR(CDR(CDR(CDR(parms))));

        int& vset_type = Wrapper<Sequence<Vertex*> >::type;
        if (!CXX_TYPEP(vset, vset_type))
               Err("digraph: bad arg 4, <sequence<vertex*>> expected", vset);

        Sequence<Vertex*>* vertices = (Sequence<Vertex*>*) CLASSDATA(vset);



	if (len == 5)
	{
        	deviate = CAR(CDR(CDR(CDR(CDR(parms)))));

        	if (!INTEGERP(deviate))
                	Err("extract: bad arg 5, integer expected (deviation)",
			     deviate);
        int deviatE = INTEGER(deviate);
	}

        Graph* induced_graph = Extract(gr, percenT, flaG, *vertices, deviatE);

        Register<Graph>::createEntry(Wrapper<MUBinGraph>::type,
                                     Wrapper<MUBinGraph>::name, induced_graph);
 
	Graph **gp = new Graph*(induced_graph);
        return STk_make_CXXwrapper(Wrapper<MUBinGraph*>::type,
                Wrapper<MUBinGraph*>::name, (void *) gp, LINK_DYNAMIC);
} 
 
void STk_Extract_Init()
{
        STk_add_new_cpp_primitive("extract",       // cmd name
                                  tc_lsubr,            // # parms
                                  (PRIMITIVE (*)(...))ExtractWrapper);
}
