#include<LINK/stkWrapper/LINK_STk.h>
#include<LINK/stkWrapper/Wrapper.h>
#include<LINK/stkWrapper/Register.h>
#include <LINK/userobj/PostAnalyze.h>



static PRIMITIVE GetNumbersWrapper(SCM parms, int len)
{
        SCM num_verts=UNBOUND, prob=UNBOUND, percent=UNBOUND, flag=UNBOUND,
            deviate=UNBOUND, seed=UNBOUND;

        int deviatE = 1;

        if (len != 6)
        {
           Err("usage: extract-ng-induced-graph <num_verts><edge probability><percent checked>", UNDEFINED);
           Err("<flag 1 or 0><1 or 0>[<deviation>]<random_seed>", UNDEFINED);
        }

        num_verts = CAR(parms);
        if (!INTEGERP(num_verts))
                Err("extract-ng-induced-graph: bad arg 1, integer expected (num_verts)", num_verts);
        int num_vertS = INTEGER(num_verts);


        prob = CAR(CDR(parms));
        if (!FLONUMP(prob))
                Err("extract-ng-induced-graph: bad arg 2, double expected (edge probability)", prob);
        double proB = FLONM(prob);


        percent = CAR(CDR(CDR(parms)));

        if (!INTEGERP(percent))
                Err("extract-ng-induced-graph: bad arg 3, integer expected (percent)", percent);
        int percenT = INTEGER(percent);

        flag = CAR(CDR(CDR(CDR(parms))));

        if (!INTEGERP(flag))
                Err("extract-ng-induced-graph: bad arg 4, integer expected (flag)", flag);
        int flaG = INTEGER(flag);


        deviate = CAR(CDR(CDR(CDR(CDR(parms)))));

        if (!INTEGERP(deviate))
                 Err("extract-ng-induced-graph: bad arg 5, integer expected (deviation)",
                             deviate);
        deviatE = INTEGER(deviate);
        

        seed = CAR(CDR(CDR(CDR(CDR(CDR(parms))))));

        if (!INTEGERP(seed))
                 Err("extract-ng-induced-graph: bad arg 6, integer expected (random seed)",
                             seed);
        int Seed = INTEGER(seed);
        

	Graph* g = GetNumbers(num_vertS, proB, percenT,
                                                     flaG, deviatE, Seed);
	Register<Graph>::createEntry(Wrapper<MUBinGraph>::type,
                                     Wrapper<MUBinGraph>::name, g);

	Graph** gp = new Graph*(g);
	return STk_make_CXXwrapper(Wrapper<MUBinGraph*>::type,
                Wrapper<MUBinGraph*>::name, (void *) gp, LINK_DYNAMIC);



}

void STk_GetNumbers_Init()
{
        STk_add_new_cpp_primitive("get-numbers",       // cmd name
                                  tc_lsubr,            // # parms
                                  (PRIMITIVE (*)(...))GetNumbersWrapper);
}

