#include<LINK/stkWrapper/LINK_STk.h>
#include<LINK/stkWrapper/Wrapper.h>
#include <LINK/userobj/PostAnalyze.h>

 
PRIMITIVE PostAnalyzeWrapper(SCM parms, int len)
{
	SCM vs=UNBOUND, g=UNBOUND, st=UNBOUND; 

	if (len == 0) {
		cerr << "post-anaylze: expected <graph*>, [set<vertex*>*], [int steps]" << endl;
		exit(2);
	}

	int steps = 0;
	Set<Vertex*> s;
	g = CAR(parms);
        Graph *gr;
        if (!(gr = getGraph(g)))   // see src/stkWrapper/stkUtils.cc
                Err("post-analyze: expected <graph*> ", g);

	if (len > 1) {
		vs = CAR(CDR(parms));
		if (INTEGERP(vs)) {
			steps = (INTEGER(vs));
		} else {
	        	int& vset_type = Wrapper<Set<Vertex*> >::type;
	        	if (!CXX_TYPEP(vs, vset_type))
	          		Err("add-subgraph: bad arg 2, <set<vertex*> > expected", vs);
	        	s = *(Set<Vertex*>*) CLASSDATA(vs);
			steps = 0;
			if (len > 2) {
				st = CAR(CDR(CDR(parms)));
				if (!INTEGERP(st))
					steps = 0;
				else    steps = (INTEGER(st));
			}
		}
	}
        Sequence<Vertex*>  result = PostAnalyze(gr, s, steps);
        Sequence<Vertex*> * new_copy = new Sequence<Vertex*> (result);
 
        return STk_make_CXXwrapper(
                Wrapper<Sequence<Vertex*>  >::type,     // stkWrapper/Wrapper.h
                Wrapper<Sequence<Vertex*>  >::name,
                (void *) new_copy,
                LINK_DYNAMIC);          // tells STk's garbage collector
                                        // to delete new_copy when the user
                                        // is finished with it
}
 
//
// This is what must go into userinit.cc
//
void STk_PostAnalyze_Init()
{
        STk_add_new_cpp_primitive("post-analyze",       // cmd name
                                  tc_lsubr,            // # parms
                                  (PRIMITIVE (*)(...))PostAnalyzeWrapper);
}

